Number of Subsequences That Satisfy the Given Sum Condition

Leetcode Daily Challenge (6th May, 2023)

Number of Subsequences That Satisfy the Given Sum Condition

Problem Statement:-

You are given an array of integers nums and an integer target.

Return the number of non-empty subsequences of nums such that the sum of the minimum and maximum element on it is less or equal to target. Since the answer may be too large, return it modulo 10<sup>9</sup> + 7.

Link: https://leetcode.com/problems/number-of-subsequences-that-satisfy-the-given-sum-condition/description/

Problem Explanation with examples:-

Example 1

Input: nums = [3,5,6,7], target = 9
Output: 4
Explanation: There are 4 subsequences that satisfy the condition.
[3] -> Min value + max value <= target (3 + 3 <= 9)
[3,5] -> (3 + 5 <= 9)
[3,5,6] -> (3 + 6 <= 9)
[3,6] -> (3 + 6 <= 9)

Example 2

Input: nums = [3,3,6,8], target = 10
Output: 6
Explanation: There are 6 subsequences that satisfy the condition. (nums can have repeated numbers).
[3] , [3] , [3,3], [3,6] , [3,6] , [3,3,6]

Example 3

Input: nums = [2,3,3,4,6,7], target = 12
Output: 61
Explanation: There are 63 non-empty subsequences, two of them do not satisfy the condition ([6,7], [7]).
Number of valid subsequences (63 - 2 = 61).

Constraints

  • 1 <= nums.length <= 10<sup>5</sup>

  • 1 <= nums[i] <= 10<sup>6</sup>

  • 1 <= target <= 10<sup>6</sup>

Intuition:-

  • As we only need the min and max values of the subsequence, we can sort the array because the order doesn't matter.

  • Now we can use two pointer approach to find the subsequence with a sum less than or equal to the target.

  • Now we can use the formula 2**(r-l+1) to find the number of subsequences possible within the range of l and r.

  • We can use a mod to avoid overflow. Return the result.

Solution:-

  • Sort the array.

  • Create two pointers l and r and initialize them to 0 and len(nums)-1 respectively.

  • Run a loop until l <= r.

  • If nums[l] + nums[r] > target, decrement r.

  • Else increment l and add (2**(r-l+1))%mod to res.

  • Return res%mod.

Code:-

JAVA Solution

class Solution {
    public int numSubseq(int[] nums, int target) {
        int mod = (int)Math.pow(10, 9) + 7;
        int l = 0;
        int r = nums.length - 1;
        Arrays.sort(nums);
        int res = 0;
        while (l <= r) {
            if (nums[l] + nums[r] > target) {
                r--;
            } else {
                l++;
                res += (int)(Math.pow(2, r - l) % mod);
            }
        }
        return res % mod;
    }
}

Python Solution

class Solution:
    def numSubseq(self, nums: List[int], target: int) -> int:
        mod = 10**9 + 7
        l = 0
        r = len(nums)-1
        nums.sort()
        res = 0
        while l <= ra:
            if nums[l] + nums[r] > target:
                r -= 1
            else:
                l += 1
                res += (2**(r-l))%mod

        return res%mod

Complexity Analysis:-

TIME:-

The time complexity is O(nlogn) + O(n) = O(nlogn) where n is the length of nums. O(nlogn) for sorting and O(n) for two pointer approach.

SPACE:-

The space complexity is O(1) as we use constant extra space.

References:-

Connect with me:-

Did you find this article valuable?

Support Leeting-LCS by becoming a sponsor. Any amount is appreciated!